"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var plantuml_generator_1 = require("./plantuml_generator");
/**
 * Class that generates PlantUML code and caches results internally.
 */
var CachingPlantUmlGenerator = /** @class */ (function (_super) {
    __extends(CachingPlantUmlGenerator, _super);
    function CachingPlantUmlGenerator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Caches the PlantUML generated for the reflections (= class or interface).
         * KEY = ID of the reflection
         * VALUE = PlantUML lines
         */
        _this.reflectionPlantUmlCache = new Map();
        return _this;
    }
    /**
     * Creates an array of PlantUML lines for generating the box (including its properties and methods) of a given type.
     * Caches the result so that another call with the same reflection will be faster.
     * @param reflection The reflection for which the PlantUML should be generated.
     * @param includeMembers Specifies whether the resulting PlantUML should include the properties and methods of
     *                       the given reflection as well.
     * @returns The PlantUML lines for the given type.
     */
    CachingPlantUmlGenerator.prototype.createPlantUmlForReflection = function (reflection, includeMembers) {
        if (!this.reflectionPlantUmlCache.has(reflection.id)) {
            this.reflectionPlantUmlCache.set(reflection.id, _super.prototype.createPlantUmlForReflection.call(this, reflection, includeMembers));
        }
        return this.reflectionPlantUmlCache.get(reflection.id);
    };
    return CachingPlantUmlGenerator;
}(plantuml_generator_1.PlantUmlGenerator));
exports.CachingPlantUmlGenerator = CachingPlantUmlGenerator;
